import { createAction, props } from '@ngrx/store';
import {
  InfoRequest,
  RoomInfo,
  UserInfoShort,
  UserInfo,
  InviteNotification,
  ExitNotification,
  ExitForcingNotification,
  UpdateFontNotification,
  UpdateResponse,
  UpdateRequest,
  OpenRequest,
  OpenResponse,
  ExitRequest,
  ExitResponse
} from '@ucap-webmessenger/protocol-room';

export const info = createAction(
  '[Messenger::Room] Info',
  props<InfoRequest>()
);

export const infoSuccess = createAction(
  '[Messenger::Room] Info Success',
  props<{
    roomInfo: RoomInfo;
    userInfoShortList: UserInfoShort[];
    userInfoList: UserInfo[];
  }>()
);

export const infoFailure = createAction(
  '[Messenger::Room] Info Failure',
  props<{ error: any }>()
);

export const inviteNotification = createAction(
  '[Messenger::Room] Invite Notification',
  props<{ noti: InviteNotification }>()
);

export const exitNotification = createAction(
  '[Messenger::Room] Exit Notification',
  props<{ noti: ExitNotification }>()
);

export const exitForcingNotification = createAction(
  '[Messenger::Room]  Exit Forcing Notification',
  props<{ noti: ExitForcingNotification }>()
);

export const updateFontNotification = createAction(
  '[Messenger::Room]  Update Font Notification',
  props<{ noti: UpdateFontNotification }>()
);

export const updateOnlyAlarm = createAction(
  '[Messenger::Room] Update Only Alarm',
  props<{ roomInfo: RoomInfo }>()
);

export const update = createAction(
  '[Messenger::Room] Update',
  props<{ req: UpdateRequest }>()
);

export const updateSuccess = createAction(
  '[Messenger::Room] Update Success',
  props<{
    res: UpdateResponse;
  }>()
);

export const updateFailure = createAction(
  '[Messenger::Room] Update Failure',
  props<{ error: any }>()
);

export const open = createAction(
  '[Messenger::Room] Open',
  props<{ req: OpenRequest }>()
);

export const openSuccess = createAction(
  '[Messenger::Room] Open Success',
  props<{
    res: OpenResponse;
  }>()
);

export const openFailure = createAction(
  '[Messenger::Room] Open Failure',
  props<{ error: any }>()
);

export const exit = createAction(
  '[Messenger::Room] Exit',
  props<ExitRequest>()
);

export const exitSuccess = createAction(
  '[Messenger::Room] Exit Success',
  props<{
    res: ExitResponse;
  }>()
);

export const exitFailure = createAction(
  '[Messenger::Room] Exit Failure',
  props<{ error: any }>()
);
